#ifndef D2SKILLS_H
#define D2SKILLS_H

#include <stdint.h>

#include "d2char.h"
#include "d2strings.h"

#define D2S_SKILL_NUMSKILLS 357
#define D2S_SKILL_MAXSKILLS_PER_CHAR 30
#define D2S_SKILL_HEADER "if"
#define D2S_SKILL_HEADER_LENGTH 2

typedef enum D2S_SKILL {
    D2S_SKILL_UNKNOWN = -1,
    D2S_SKILL_ATTACK = 0,
    D2S_SKILL_KICK,
    D2S_SKILL_THROW_ITEM,
    D2S_SKILL_UNSUMMON,
    D2S_SKILL_LEFT_HAND_THROW,
    D2S_SKILL_LEFT_HAND_SWING,
    D2S_SKILL_MAGIC_ARROW,
    D2S_SKILL_FIRE_ARROW,
    D2S_SKILL_INNER_SIGHT,
    D2S_SKILL_CRITICAL_STRIKE,
    D2S_SKILL_JAB,
    D2S_SKILL_COLD_ARROW,
    D2S_SKILL_MULTIPLE_SHOT,
    D2S_SKILL_DODGE,
    D2S_SKILL_POWER_STRIKE,
    D2S_SKILL_POISON_JAVELIN,
    D2S_SKILL_EXPLODING_ARROW,
    D2S_SKILL_SLOW_MISSILES,
    D2S_SKILL_AVOID,
    D2S_SKILL_IMPALE,
    D2S_SKILL_LIGHTNING_BOLT,
    D2S_SKILL_ICE_ARROW,
    D2S_SKILL_GUIDED_ARROW,
    D2S_SKILL_PENETRATE,
    D2S_SKILL_CHARGED_STRIKE,
    D2S_SKILL_PLAGUE_JAVELIN,
    D2S_SKILL_STRAFE,
    D2S_SKILL_IMMOLATION_ARROW,
    D2S_SKILL_DOPPLEZON,
    D2S_SKILL_EVADE,
    D2S_SKILL_FEND,
    D2S_SKILL_FREEZING_ARROW,
    D2S_SKILL_VALKYRIE,
    D2S_SKILL_PIERCE,
    D2S_SKILL_LIGHTNING_STRIKE,
    D2S_SKILL_LIGHTNING_FURY,
    D2S_SKILL_FIRE_BOLT,
    D2S_SKILL_WARMTH,
    D2S_SKILL_CHARGED_BOLT,
    D2S_SKILL_ICE_BOLT,
    D2S_SKILL_FROZEN_ARMOR,
    D2S_SKILL_INFERNO,
    D2S_SKILL_STATIC_FIELD,
    D2S_SKILL_TELEKINESIS,
    D2S_SKILL_FROST_NOVA,
    D2S_SKILL_ICE_BLAST,
    D2S_SKILL_BLAZE,
    D2S_SKILL_FIRE_BALL,
    D2S_SKILL_NOVA,
    D2S_SKILL_LIGHTNING,
    D2S_SKILL_SHIVER_ARMOR,
    D2S_SKILL_FIRE_WALL,
    D2S_SKILL_ENCHANT,
    D2S_SKILL_CHAIN_LIGHTNING,
    D2S_SKILL_TELEPORT,
    D2S_SKILL_GLACIAL_SPIKE,
    D2S_SKILL_METEOR,
    D2S_SKILL_THUNDER_STORM,
    D2S_SKILL_ENERGY_SHIELD,
    D2S_SKILL_BLIZZARD,
    D2S_SKILL_CHILLING_ARMOR,
    D2S_SKILL_FIRE_MASTERY,
    D2S_SKILL_HYDRA,
    D2S_SKILL_LIGHTNING_MASTERY,
    D2S_SKILL_FROZEN_ORB,
    D2S_SKILL_COLD_MASTERY,
    D2S_SKILL_AMPLIFY_DAMAGE,
    D2S_SKILL_TEETH,
    D2S_SKILL_BONE_ARMOR,
    D2S_SKILL_SKELETON_MASTERY,
    D2S_SKILL_RAISE_SKELETON,
    D2S_SKILL_DIM_VISION,
    D2S_SKILL_WEAKEN,
    D2S_SKILL_POISON_DAGGER,
    D2S_SKILL_CORPSE_EXPLOSION,
    D2S_SKILL_CLAY_GOLEM,
    D2S_SKILL_IRON_MAIDEN,
    D2S_SKILL_TERROR,
    D2S_SKILL_BONE_WALL,
    D2S_SKILL_GOLEM_MASTERY,
    D2S_SKILL_RAISE_SKELETAL_MAGE,
    D2S_SKILL_CONFUSE,
    D2S_SKILL_LIFE_TAP,
    D2S_SKILL_POISON_EXPLOSION,
    D2S_SKILL_BONE_SPEAR,
    D2S_SKILL_BLOOD_GOLEM,
    D2S_SKILL_ATTRACT,
    D2S_SKILL_DECREPIFY,
    D2S_SKILL_BONE_PRISON,
    D2S_SKILL_SUMMON_RESIST,
    D2S_SKILL_IRON_GOLEM,
    D2S_SKILL_LOWER_RESIST,
    D2S_SKILL_POISON_NOVA,
    D2S_SKILL_BONE_SPIRIT,
    D2S_SKILL_FIRE_GOLEM,
    D2S_SKILL_REVIVE,
    D2S_SKILL_SACRIFICE,
    D2S_SKILL_SMITE,
    D2S_SKILL_MIGHT,
    D2S_SKILL_PRAYER,
    D2S_SKILL_RESIST_FIRE,
    D2S_SKILL_HOLY_BOLT,
    D2S_SKILL_HOLY_FIRE,
    D2S_SKILL_THORNS,
    D2S_SKILL_DEFIANCE,
    D2S_SKILL_RESIST_COLD,
    D2S_SKILL_ZEAL,
    D2S_SKILL_CHARGE,
    D2S_SKILL_BLESSED_AIM,
    D2S_SKILL_CLEANSING,
    D2S_SKILL_RESIST_LIGHTNING,
    D2S_SKILL_VENGEANCE,
    D2S_SKILL_BLESSED_HAMMER,
    D2S_SKILL_CONCENTRATION,
    D2S_SKILL_HOLY_FREEZE,
    D2S_SKILL_VIGOR,
    D2S_SKILL_CONVERSION,
    D2S_SKILL_HOLY_SHIELD,
    D2S_SKILL_HOLY_SHOCK,
    D2S_SKILL_SANCTUARY,
    D2S_SKILL_MEDITATION,
    D2S_SKILL_FIST_OF_THE_HEAVENS,
    D2S_SKILL_FANATICISM,
    D2S_SKILL_CONVICTION,
    D2S_SKILL_REDEMPTION,
    D2S_SKILL_SALVATION,
    D2S_SKILL_BASH,
    D2S_SKILL_SWORD_MASTERY,
    D2S_SKILL_AXE_MASTERY,
    D2S_SKILL_MACE_MASTERY,
    D2S_SKILL_HOWL,
    D2S_SKILL_FIND_POTION,
    D2S_SKILL_LEAP,
    D2S_SKILL_DOUBLE_SWING,
    D2S_SKILL_POLE_ARM_MASTERY,
    D2S_SKILL_THROWING_MASTERY,
    D2S_SKILL_SPEAR_MASTERY,
    D2S_SKILL_TAUNT,
    D2S_SKILL_SHOUT,
    D2S_SKILL_STUN,
    D2S_SKILL_DOUBLE_THROW,
    D2S_SKILL_INCREASED_STAMINA,
    D2S_SKILL_FIND_ITEM,
    D2S_SKILL_LEAP_ATTACK,
    D2S_SKILL_CONCENTRATE,
    D2S_SKILL_IRON_SKIN,
    D2S_SKILL_BATTLE_CRY,
    D2S_SKILL_FRENZY,
    D2S_SKILL_INCREASED_SPEED,
    D2S_SKILL_BATTLE_ORDERS,
    D2S_SKILL_GRIM_WARD,
    D2S_SKILL_WHIRLWIND,
    D2S_SKILL_BERSERK,
    D2S_SKILL_NATURAL_RESISTANCE,
    D2S_SKILL_WAR_CRY,
    D2S_SKILL_BATTLE_COMMAND,
    D2S_SKILL_FIRE_HIT,
    D2S_SKILL_UNHOLY_BOLT,
    D2S_SKILL_SKELETON_RAISE,
    D2S_SKILL_MAGGOT_EGG,
    D2S_SKILL_SHAMAN_FIRE,
    D2S_SKILL_MAGOTTUP,
    D2S_SKILL_MAGOTTDOWN,
    D2S_SKILL_MAGOTTLAY,
    D2S_SKILL_ANDRIAL_SPRAY,
    D2S_SKILL_JUMP,
    D2S_SKILL_SWARM_MOVE,
    D2S_SKILL_NEST,
    D2S_SKILL_QUICK_STRIKE,
    D2S_SKILL_VAMPIRE_FIREBALL,
    D2S_SKILL_VAMPIRE_FIREWALL,
    D2S_SKILL_VAMPIRE_METEOR,
    D2S_SKILL_GARGOYLE_TRAP,
    D2S_SKILL_SPIDER_LAY,
    D2S_SKILL_VAMPIRE_HEAL,
    D2S_SKILL_VAMPIRE_RAISE,
    D2S_SKILL_SUBMERGE,
    D2S_SKILL_FETISH_AURA,
    D2S_SKILL_FETISH_INFERNO,
    D2S_SKILL_ZAKARUM_HEAL,
    D2S_SKILL_EMERGE,
    D2S_SKILL_RESURRECT,
    D2S_SKILL_BESTOW,
    D2S_SKILL_MISSILE_SKILL1,
    D2S_SKILL_MON_TELEPORT,
    D2S_SKILL_PRIME_LIGHTNING,
    D2S_SKILL_PRIME_BOLT,
    D2S_SKILL_PRIME_BLAZE,
    D2S_SKILL_PRIME_FIREWALL,
    D2S_SKILL_PRIME_SPIKE,
    D2S_SKILL_PRIME_ICE_NOVA,
    D2S_SKILL_PRIME_POISON_BALL,
    D2S_SKILL_PRIME_POISON_NOVA,
    D2S_SKILL_DIABLIGHT,
    D2S_SKILL_DIABCOLD,
    D2S_SKILL_DIABFIRE,
    D2S_SKILL_FINGERMAGESPIDER,
    D2S_SKILL_DIABWALL,
    D2S_SKILL_DIABRUN,
    D2S_SKILL_DIABPRISON,
    D2S_SKILL_POISON_BALL_TRAP,
    D2S_SKILL_ANDY_POISON_BOLT,
    D2S_SKILL_HIREABLE_MISSILE,
    D2S_SKILL_DESERT_TURRET,
    D2S_SKILL_ARCANE_TOWER,
    D2S_SKILL_MONBLIZZARD,
    D2S_SKILL_MOSQUITO,
    D2S_SKILL_CURSED_BALL_TRAP_RIGHT,
    D2S_SKILL_CURSED_BALL_TRAP_LEFT,
    D2S_SKILL_MONFROZENARMOR,
    D2S_SKILL_MONBONEARMOR,
    D2S_SKILL_MONBONESPIRIT,
    D2S_SKILL_MONCURSECAST,
    D2S_SKILL_HELLMETEOR,
    D2S_SKILL_REGURGITATOREAT,
    D2S_SKILL_MONFRENZY,
    D2S_SKILL_QUEENDEATH,
    D2S_SKILL_SCROLL_OF_IDENTIFY,
    D2S_SKILL_BOOK_OF_IDENTIFY,
    D2S_SKILL_SCROLL_OF_TOWNPORTAL,
    D2S_SKILL_BOOK_OF_TOWNPORTAL,
    D2S_SKILL_RAVEN,
    D2S_SKILL_POISON_CREEPER,
    D2S_SKILL_WEARWOLF,
    D2S_SKILL_SHAPE_SHIFTING,
    D2S_SKILL_FIRESTORM,
    D2S_SKILL_OAK_SAGE,
    D2S_SKILL_SUMMON_SPIRIT_WOLF,
    D2S_SKILL_WEARBEAR,
    D2S_SKILL_MOLTEN_BOULDER,
    D2S_SKILL_ARCTIC_BLAST,
    D2S_SKILL_CYCLE_OF_LIFE,
    D2S_SKILL_FERAL_RAGE,
    D2S_SKILL_MAUL,
    D2S_SKILL_ERUPTION,
    D2S_SKILL_CYCLONE_ARMOR,
    D2S_SKILL_HEART_OF_WOLVERINE,
    D2S_SKILL_SUMMON_FENRIS,
    D2S_SKILL_RABIES,
    D2S_SKILL_FIRE_CLAWS,
    D2S_SKILL_TWISTER,
    D2S_SKILL_VINES,
    D2S_SKILL_HUNGER,
    D2S_SKILL_SHOCK_WAVE,
    D2S_SKILL_VOLCANO,
    D2S_SKILL_TORNADO,
    D2S_SKILL_SPIRIT_OF_BARBS,
    D2S_SKILL_SUMMON_GRIZZLY,
    D2S_SKILL_FURY,
    D2S_SKILL_ARMAGEDDON,
    D2S_SKILL_HURRICANE,
    D2S_SKILL_FIRE_BLAST,
    D2S_SKILL_CLAW_MASTERY,
    D2S_SKILL_PSYCHIC_HAMMER,
    D2S_SKILL_TIGER_STRIKE,
    D2S_SKILL_DRAGON_TALON,
    D2S_SKILL_SHOCK_FIELD,
    D2S_SKILL_BLADE_SENTINEL,
    D2S_SKILL_QUICKNESS,
    D2S_SKILL_FISTS_OF_FIRE,
    D2S_SKILL_DRAGON_CLAW,
    D2S_SKILL_CHARGED_BOLT_SENTRY,
    D2S_SKILL_WAKE_OF_FIRE_SENTRY,
    D2S_SKILL_WEAPON_BLOCK,
    D2S_SKILL_CLOAK_OF_SHADOWS,
    D2S_SKILL_COBRA_STRIKE,
    D2S_SKILL_BLADE_FURY,
    D2S_SKILL_FADE,
    D2S_SKILL_SHADOW_WARRIOR,
    D2S_SKILL_CLAWS_OF_THUNDER,
    D2S_SKILL_DRAGON_TAIL,
    D2S_SKILL_LIGHTNING_SENTRY,
    D2S_SKILL_INFERNO_SENTRY,
    D2S_SKILL_MIND_BLAST,
    D2S_SKILL_BLADES_OF_ICE,
    D2S_SKILL_DRAGON_FLIGHT,
    D2S_SKILL_DEATH_SENTRY,
    D2S_SKILL_BLADE_SHIELD,
    D2S_SKILL_VENOM,
    D2S_SKILL_SHADOW_MASTER,
    D2S_SKILL_ROYAL_STRIKE,
    D2S_SKILL_WAKE_OF_DESTRUCTION_SENTRY,
    D2S_SKILL_IMP_INFERNO,
    D2S_SKILL_IMP_FIREBALL,
    D2S_SKILL_BAAL_TAUNT,
    D2S_SKILL_BAAL_CORPSE_EXPLODE,
    D2S_SKILL_BAAL_MONSTER_SPAWN,
    D2S_SKILL_CATAPULT_CHARGED_BALL,
    D2S_SKILL_CATAPULT_SPIKE_BALL,
    D2S_SKILL_SUCK_BLOOD,
    D2S_SKILL_CRY_HELP,
    D2S_SKILL_HEALING_VORTEX,
    D2S_SKILL_TELEPORT_2,
    D2S_SKILL_SELF_RESURRECT,
    D2S_SKILL_VINE_ATTACK,
    D2S_SKILL_OVERSEER_WHIP,
    D2S_SKILL_BARBS_AURA,
    D2S_SKILL_WOLVERINE_AURA,
    D2S_SKILL_OAK_SAGE_AURA,
    D2S_SKILL_IMP_FIRE_MISSILE,
    D2S_SKILL_IMPREGNATE,
    D2S_SKILL_SIEGE_BEAST_STOMP,
    D2S_SKILL_MINIONSPAWNER,
    D2S_SKILL_CATAPULTBLIZZARD,
    D2S_SKILL_CATAPULTPLAGUE,
    D2S_SKILL_CATAPULTMETEOR,
    D2S_SKILL_BOLTSENTRY,
    D2S_SKILL_CORPSECYCLER,
    D2S_SKILL_DEATHMAUL,
    D2S_SKILL_DEFENSE_CURSE,
    D2S_SKILL_BLOOD_MANA,
    D2S_SKILL_MON_INFERNO_SENTRY,
    D2S_SKILL_MON_DEATH_SENTRY,
    D2S_SKILL_SENTRY_LIGHTNING,
    D2S_SKILL_FENRIS_RAGE,
    D2S_SKILL_BAAL_TENTACLE,
    D2S_SKILL_BAAL_NOVA,
    D2S_SKILL_BAAL_INFERNO,
    D2S_SKILL_BAAL_COLD_MISSILES,
    D2S_SKILL_MEGA_DEMON_INFERNO,
    D2S_SKILL_EVIL_HUT_SPAWNER,
    D2S_SKILL_COUNTESS_FIREWALL,
    D2S_SKILL_IMPBOLT,
    D2S_SKILL_HORROR_ARCTIC_BLAST,
    D2S_SKILL_DEATH_SENTRY_LTNG,
    D2S_SKILL_VINECYCLER,
    D2S_SKILL_BEARSMITE,
    D2S_SKILL_RESURRECT2,
    D2S_SKILL_BLOODLORD_FRENZY,
    D2S_SKILL_BAAL_TELEPORT,
    D2S_SKILL_IMP_TELEPORT,
    D2S_SKILL_BAAL_CLONE_TELEPORT,
    D2S_SKILL_ZAKARUM_LIGHTNING,
    D2S_SKILL_VAMPIRE_MISSILE,
    D2S_SKILL_MEPHISTO_MISSILE,
    D2S_SKILL_DOOM_KNIGHT_MISSILE,
    D2S_SKILL_ROGUE_MISSILE,
    D2S_SKILL_HYDRA_MISSILE,
    D2S_SKILL_NECRO_MAGE_MISSILE,
    D2S_SKILL_MONBOW,
    D2S_SKILL_MONFIREARROW,
    D2S_SKILL_MONCOLDARROW,
    D2S_SKILL_MONEXPLODINGARROW,
    D2S_SKILL_MONFREEZINGARROW,
    D2S_SKILL_MONPOWERSTRIKE,
    D2S_SKILL_SUCCUBUSBOLT,
    D2S_SKILL_MEPHFROSTNOVA,
    D2S_SKILL_MONICESPEAR,
    D2S_SKILL_SHAMAN_ICE,
    D2S_SKILL_DIABLOGEDDON,
    D2S_SKILL_DELERIUM_CHANGE,
    D2S_SKILL_NIHLATHAK_CORPSE_EXPLOSION,
    D2S_SKILL_SERPENT_CHARGE,
    D2S_SKILL_TRAP_NOVA,
    D2S_SKILL_UNHOLY_BOLTEX,
    D2S_SKILL_SHAMAN_FIREEX,
    D2S_SKILL_IMP_FIRE_MISSILE_EX,
} D2S_SKILL;

const D2S_SKILL amazonSkills[D2S_SKILL_MAXSKILLS_PER_CHAR] = {
    D2S_SKILL_MAGIC_ARROW,
    D2S_SKILL_FIRE_ARROW,
    D2S_SKILL_INNER_SIGHT,
    D2S_SKILL_CRITICAL_STRIKE,
    D2S_SKILL_JAB,
    D2S_SKILL_COLD_ARROW,
    D2S_SKILL_MULTIPLE_SHOT,
    D2S_SKILL_DODGE,
    D2S_SKILL_POWER_STRIKE,
    D2S_SKILL_POISON_JAVELIN,
    D2S_SKILL_EXPLODING_ARROW,
    D2S_SKILL_SLOW_MISSILES,
    D2S_SKILL_AVOID,
    D2S_SKILL_IMPALE,
    D2S_SKILL_LIGHTNING_BOLT,
    D2S_SKILL_ICE_ARROW,
    D2S_SKILL_GUIDED_ARROW,
    D2S_SKILL_PENETRATE,
    D2S_SKILL_CHARGED_STRIKE,
    D2S_SKILL_PLAGUE_JAVELIN,
    D2S_SKILL_STRAFE,
    D2S_SKILL_IMMOLATION_ARROW,
    D2S_SKILL_DOPPLEZON,
    D2S_SKILL_EVADE,
    D2S_SKILL_FEND,
    D2S_SKILL_FREEZING_ARROW,
    D2S_SKILL_VALKYRIE,
    D2S_SKILL_PIERCE,
    D2S_SKILL_LIGHTNING_STRIKE,
    D2S_SKILL_LIGHTNING_FURY
};

const D2S_SKILL sorceressSkills[D2S_SKILL_MAXSKILLS_PER_CHAR] = {
    D2S_SKILL_FIRE_BOLT,
    D2S_SKILL_WARMTH,
    D2S_SKILL_CHARGED_BOLT,
    D2S_SKILL_ICE_BOLT,
    D2S_SKILL_FROZEN_ARMOR,
    D2S_SKILL_INFERNO,
    D2S_SKILL_STATIC_FIELD,
    D2S_SKILL_TELEKINESIS,
    D2S_SKILL_FROST_NOVA,
    D2S_SKILL_ICE_BLAST,
    D2S_SKILL_BLAZE,
    D2S_SKILL_FIRE_BALL,
    D2S_SKILL_NOVA,
    D2S_SKILL_LIGHTNING,
    D2S_SKILL_SHIVER_ARMOR,
    D2S_SKILL_FIRE_WALL,
    D2S_SKILL_ENCHANT,
    D2S_SKILL_CHAIN_LIGHTNING,
    D2S_SKILL_TELEPORT,
    D2S_SKILL_GLACIAL_SPIKE,
    D2S_SKILL_METEOR,
    D2S_SKILL_THUNDER_STORM,
    D2S_SKILL_ENERGY_SHIELD,
    D2S_SKILL_BLIZZARD,
    D2S_SKILL_CHILLING_ARMOR,
    D2S_SKILL_FIRE_MASTERY,
    D2S_SKILL_HYDRA,
    D2S_SKILL_LIGHTNING_MASTERY,
    D2S_SKILL_FROZEN_ORB,
    D2S_SKILL_COLD_MASTERY
};

const D2S_SKILL necromancerSkills[D2S_SKILL_MAXSKILLS_PER_CHAR] = {
    D2S_SKILL_AMPLIFY_DAMAGE,
    D2S_SKILL_TEETH,
    D2S_SKILL_BONE_ARMOR,
    D2S_SKILL_SKELETON_MASTERY,
    D2S_SKILL_RAISE_SKELETON,
    D2S_SKILL_DIM_VISION,
    D2S_SKILL_WEAKEN,
    D2S_SKILL_POISON_DAGGER,
    D2S_SKILL_CORPSE_EXPLOSION,
    D2S_SKILL_CLAY_GOLEM,
    D2S_SKILL_IRON_MAIDEN,
    D2S_SKILL_TERROR,
    D2S_SKILL_BONE_WALL,
    D2S_SKILL_GOLEM_MASTERY,
    D2S_SKILL_RAISE_SKELETAL_MAGE,
    D2S_SKILL_CONFUSE,
    D2S_SKILL_LIFE_TAP,
    D2S_SKILL_POISON_EXPLOSION,
    D2S_SKILL_BONE_SPEAR,
    D2S_SKILL_BLOOD_GOLEM,
    D2S_SKILL_ATTRACT,
    D2S_SKILL_DECREPIFY,
    D2S_SKILL_BONE_PRISON,
    D2S_SKILL_SUMMON_RESIST,
    D2S_SKILL_IRON_GOLEM,
    D2S_SKILL_LOWER_RESIST,
    D2S_SKILL_POISON_NOVA,
    D2S_SKILL_BONE_SPIRIT,
    D2S_SKILL_FIRE_GOLEM,
    D2S_SKILL_REVIVE
};

const D2S_SKILL paladinSkills[D2S_SKILL_MAXSKILLS_PER_CHAR] = {
    D2S_SKILL_SACRIFICE,
    D2S_SKILL_SMITE,
    D2S_SKILL_MIGHT,
    D2S_SKILL_PRAYER,
    D2S_SKILL_RESIST_FIRE,
    D2S_SKILL_HOLY_BOLT,
    D2S_SKILL_HOLY_FIRE,
    D2S_SKILL_THORNS,
    D2S_SKILL_DEFIANCE,
    D2S_SKILL_RESIST_COLD,
    D2S_SKILL_ZEAL,
    D2S_SKILL_CHARGE,
    D2S_SKILL_BLESSED_AIM,
    D2S_SKILL_CLEANSING,
    D2S_SKILL_RESIST_LIGHTNING,
    D2S_SKILL_VENGEANCE,
    D2S_SKILL_BLESSED_HAMMER,
    D2S_SKILL_CONCENTRATION,
    D2S_SKILL_HOLY_FREEZE,
    D2S_SKILL_VIGOR,
    D2S_SKILL_CONVERSION,
    D2S_SKILL_HOLY_SHIELD,
    D2S_SKILL_HOLY_SHOCK,
    D2S_SKILL_SANCTUARY,
    D2S_SKILL_MEDITATION,
    D2S_SKILL_FIST_OF_THE_HEAVENS,
    D2S_SKILL_FANATICISM,
    D2S_SKILL_CONVICTION,
    D2S_SKILL_REDEMPTION,
    D2S_SKILL_SALVATION
};

const D2S_SKILL barbarianSkills[D2S_SKILL_MAXSKILLS_PER_CHAR] = {
    D2S_SKILL_BASH,
    D2S_SKILL_SWORD_MASTERY,
    D2S_SKILL_AXE_MASTERY,
    D2S_SKILL_MACE_MASTERY,
    D2S_SKILL_HOWL,
    D2S_SKILL_FIND_POTION,
    D2S_SKILL_LEAP,
    D2S_SKILL_DOUBLE_SWING,
    D2S_SKILL_POLE_ARM_MASTERY,
    D2S_SKILL_THROWING_MASTERY,
    D2S_SKILL_SPEAR_MASTERY,
    D2S_SKILL_TAUNT,
    D2S_SKILL_SHOUT,
    D2S_SKILL_STUN,
    D2S_SKILL_DOUBLE_THROW,
    D2S_SKILL_INCREASED_STAMINA,
    D2S_SKILL_FIND_ITEM,
    D2S_SKILL_LEAP_ATTACK,
    D2S_SKILL_CONCENTRATE,
    D2S_SKILL_IRON_SKIN,
    D2S_SKILL_BATTLE_CRY,
    D2S_SKILL_FRENZY,
    D2S_SKILL_INCREASED_SPEED,
    D2S_SKILL_BATTLE_ORDERS,
    D2S_SKILL_GRIM_WARD,
    D2S_SKILL_WHIRLWIND,
    D2S_SKILL_BERSERK,
    D2S_SKILL_NATURAL_RESISTANCE,
    D2S_SKILL_WAR_CRY,
    D2S_SKILL_BATTLE_COMMAND
};

const D2S_SKILL druidSkills[D2S_SKILL_MAXSKILLS_PER_CHAR] = {
    D2S_SKILL_RAVEN,
    D2S_SKILL_POISON_CREEPER,
    D2S_SKILL_WEARWOLF,
    D2S_SKILL_SHAPE_SHIFTING,
    D2S_SKILL_FIRESTORM,
    D2S_SKILL_OAK_SAGE,
    D2S_SKILL_SUMMON_SPIRIT_WOLF,
    D2S_SKILL_WEARBEAR,
    D2S_SKILL_MOLTEN_BOULDER,
    D2S_SKILL_ARCTIC_BLAST,
    D2S_SKILL_CYCLE_OF_LIFE,
    D2S_SKILL_FERAL_RAGE,
    D2S_SKILL_MAUL,
    D2S_SKILL_ERUPTION,
    D2S_SKILL_CYCLONE_ARMOR,
    D2S_SKILL_HEART_OF_WOLVERINE,
    D2S_SKILL_SUMMON_FENRIS,
    D2S_SKILL_RABIES,
    D2S_SKILL_FIRE_CLAWS,
    D2S_SKILL_TWISTER,
    D2S_SKILL_VINES,
    D2S_SKILL_HUNGER,
    D2S_SKILL_SHOCK_WAVE,
    D2S_SKILL_VOLCANO,
    D2S_SKILL_TORNADO,
    D2S_SKILL_SPIRIT_OF_BARBS,
    D2S_SKILL_SUMMON_GRIZZLY,
    D2S_SKILL_FURY,
    D2S_SKILL_ARMAGEDDON,
    D2S_SKILL_HURRICANE
};

const D2S_SKILL assassinSkills[D2S_SKILL_MAXSKILLS_PER_CHAR] = {
    D2S_SKILL_FIRE_BLAST,
    D2S_SKILL_CLAW_MASTERY,
    D2S_SKILL_PSYCHIC_HAMMER,
    D2S_SKILL_TIGER_STRIKE,
    D2S_SKILL_DRAGON_TALON,
    D2S_SKILL_SHOCK_FIELD,
    D2S_SKILL_BLADE_SENTINEL,
    D2S_SKILL_QUICKNESS,
    D2S_SKILL_FISTS_OF_FIRE,
    D2S_SKILL_DRAGON_CLAW,
    D2S_SKILL_CHARGED_BOLT_SENTRY,
    D2S_SKILL_WAKE_OF_FIRE_SENTRY,
    D2S_SKILL_WEAPON_BLOCK,
    D2S_SKILL_CLOAK_OF_SHADOWS,
    D2S_SKILL_COBRA_STRIKE,
    D2S_SKILL_BLADE_FURY,
    D2S_SKILL_FADE,
    D2S_SKILL_SHADOW_WARRIOR,
    D2S_SKILL_CLAWS_OF_THUNDER,
    D2S_SKILL_DRAGON_TAIL,
    D2S_SKILL_LIGHTNING_SENTRY,
    D2S_SKILL_INFERNO_SENTRY,
    D2S_SKILL_MIND_BLAST,
    D2S_SKILL_BLADES_OF_ICE,
    D2S_SKILL_DRAGON_FLIGHT,
    D2S_SKILL_DEATH_SENTRY,
    D2S_SKILL_BLADE_SHIELD,
    D2S_SKILL_VENOM,
    D2S_SKILL_SHADOW_MASTER,
    D2S_SKILL_ROYAL_STRIKE
};

const char* const skillNames[] = {
    D2S_SKILL_0,
    D2S_SKILL_1,
    D2S_SKILL_2,
    D2S_SKILL_3,
    D2S_SKILL_4,
    D2S_SKILL_5,
    D2S_SKILL_6,
    D2S_SKILL_7,
    D2S_SKILL_8,
    D2S_SKILL_9,
    D2S_SKILL_10,
    D2S_SKILL_11,
    D2S_SKILL_12,
    D2S_SKILL_13,
    D2S_SKILL_14,
    D2S_SKILL_15,
    D2S_SKILL_16,
    D2S_SKILL_17,
    D2S_SKILL_18,
    D2S_SKILL_19,
    D2S_SKILL_20,
    D2S_SKILL_21,
    D2S_SKILL_22,
    D2S_SKILL_23,
    D2S_SKILL_24,
    D2S_SKILL_25,
    D2S_SKILL_26,
    D2S_SKILL_27,
    D2S_SKILL_28,
    D2S_SKILL_29,
    D2S_SKILL_30,
    D2S_SKILL_31,
    D2S_SKILL_32,
    D2S_SKILL_33,
    D2S_SKILL_34,
    D2S_SKILL_35,
    D2S_SKILL_36,
    D2S_SKILL_37,
    D2S_SKILL_38,
    D2S_SKILL_39,
    D2S_SKILL_40,
    D2S_SKILL_41,
    D2S_SKILL_42,
    D2S_SKILL_43,
    D2S_SKILL_44,
    D2S_SKILL_45,
    D2S_SKILL_46,
    D2S_SKILL_47,
    D2S_SKILL_48,
    D2S_SKILL_49,
    D2S_SKILL_50,
    D2S_SKILL_51,
    D2S_SKILL_52,
    D2S_SKILL_53,
    D2S_SKILL_54,
    D2S_SKILL_55,
    D2S_SKILL_56,
    D2S_SKILL_57,
    D2S_SKILL_58,
    D2S_SKILL_59,
    D2S_SKILL_60,
    D2S_SKILL_61,
    D2S_SKILL_62,
    D2S_SKILL_63,
    D2S_SKILL_64,
    D2S_SKILL_65,
    D2S_SKILL_66,
    D2S_SKILL_67,
    D2S_SKILL_68,
    D2S_SKILL_69,
    D2S_SKILL_70,
    D2S_SKILL_71,
    D2S_SKILL_72,
    D2S_SKILL_73,
    D2S_SKILL_74,
    D2S_SKILL_75,
    D2S_SKILL_76,
    D2S_SKILL_77,
    D2S_SKILL_78,
    D2S_SKILL_79,
    D2S_SKILL_80,
    D2S_SKILL_81,
    D2S_SKILL_82,
    D2S_SKILL_83,
    D2S_SKILL_84,
    D2S_SKILL_85,
    D2S_SKILL_86,
    D2S_SKILL_87,
    D2S_SKILL_88,
    D2S_SKILL_89,
    D2S_SKILL_90,
    D2S_SKILL_91,
    D2S_SKILL_92,
    D2S_SKILL_93,
    D2S_SKILL_94,
    D2S_SKILL_95,
    D2S_SKILL_96,
    D2S_SKILL_97,
    D2S_SKILL_98,
    D2S_SKILL_99,
    D2S_SKILL_100,
    D2S_SKILL_101,
    D2S_SKILL_102,
    D2S_SKILL_103,
    D2S_SKILL_104,
    D2S_SKILL_105,
    D2S_SKILL_106,
    D2S_SKILL_107,
    D2S_SKILL_108,
    D2S_SKILL_109,
    D2S_SKILL_110,
    D2S_SKILL_111,
    D2S_SKILL_112,
    D2S_SKILL_113,
    D2S_SKILL_114,
    D2S_SKILL_115,
    D2S_SKILL_116,
    D2S_SKILL_117,
    D2S_SKILL_118,
    D2S_SKILL_119,
    D2S_SKILL_120,
    D2S_SKILL_121,
    D2S_SKILL_122,
    D2S_SKILL_123,
    D2S_SKILL_124,
    D2S_SKILL_125,
    D2S_SKILL_126,
    D2S_SKILL_127,
    D2S_SKILL_128,
    D2S_SKILL_129,
    D2S_SKILL_130,
    D2S_SKILL_131,
    D2S_SKILL_132,
    D2S_SKILL_133,
    D2S_SKILL_134,
    D2S_SKILL_135,
    D2S_SKILL_136,
    D2S_SKILL_137,
    D2S_SKILL_138,
    D2S_SKILL_139,
    D2S_SKILL_140,
    D2S_SKILL_141,
    D2S_SKILL_142,
    D2S_SKILL_143,
    D2S_SKILL_144,
    D2S_SKILL_145,
    D2S_SKILL_146,
    D2S_SKILL_147,
    D2S_SKILL_148,
    D2S_SKILL_149,
    D2S_SKILL_150,
    D2S_SKILL_151,
    D2S_SKILL_152,
    D2S_SKILL_153,
    D2S_SKILL_154,
    D2S_SKILL_155,
    D2S_SKILL_156,
    D2S_SKILL_157,
    D2S_SKILL_158,
    D2S_SKILL_159,
    D2S_SKILL_160,
    D2S_SKILL_161,
    D2S_SKILL_162,
    D2S_SKILL_163,
    D2S_SKILL_164,
    D2S_SKILL_165,
    D2S_SKILL_166,
    D2S_SKILL_167,
    D2S_SKILL_168,
    D2S_SKILL_169,
    D2S_SKILL_170,
    D2S_SKILL_171,
    D2S_SKILL_172,
    D2S_SKILL_173,
    D2S_SKILL_174,
    D2S_SKILL_175,
    D2S_SKILL_176,
    D2S_SKILL_177,
    D2S_SKILL_178,
    D2S_SKILL_179,
    D2S_SKILL_180,
    D2S_SKILL_181,
    D2S_SKILL_182,
    D2S_SKILL_183,
    D2S_SKILL_184,
    D2S_SKILL_185,
    D2S_SKILL_186,
    D2S_SKILL_187,
    D2S_SKILL_188,
    D2S_SKILL_189,
    D2S_SKILL_190,
    D2S_SKILL_191,
    D2S_SKILL_192,
    D2S_SKILL_193,
    D2S_SKILL_194,
    D2S_SKILL_195,
    D2S_SKILL_196,
    D2S_SKILL_197,
    D2S_SKILL_198,
    D2S_SKILL_199,
    D2S_SKILL_200,
    D2S_SKILL_201,
    D2S_SKILL_202,
    D2S_SKILL_203,
    D2S_SKILL_204,
    D2S_SKILL_205,
    D2S_SKILL_206,
    D2S_SKILL_207,
    D2S_SKILL_208,
    D2S_SKILL_209,
    D2S_SKILL_210,
    D2S_SKILL_211,
    D2S_SKILL_212,
    D2S_SKILL_213,
    D2S_SKILL_214,
    D2S_SKILL_215,
    D2S_SKILL_216,
    D2S_SKILL_217,
    D2S_SKILL_218,
    D2S_SKILL_219,
    D2S_SKILL_220,
    D2S_SKILL_221,
    D2S_SKILL_222,
    D2S_SKILL_223,
    D2S_SKILL_224,
    D2S_SKILL_225,
    D2S_SKILL_226,
    D2S_SKILL_227,
    D2S_SKILL_228,
    D2S_SKILL_229,
    D2S_SKILL_230,
    D2S_SKILL_231,
    D2S_SKILL_232,
    D2S_SKILL_233,
    D2S_SKILL_234,
    D2S_SKILL_235,
    D2S_SKILL_236,
    D2S_SKILL_237,
    D2S_SKILL_238,
    D2S_SKILL_239,
    D2S_SKILL_240,
    D2S_SKILL_241,
    D2S_SKILL_242,
    D2S_SKILL_243,
    D2S_SKILL_244,
    D2S_SKILL_245,
    D2S_SKILL_246,
    D2S_SKILL_247,
    D2S_SKILL_248,
    D2S_SKILL_249,
    D2S_SKILL_250,
    D2S_SKILL_251,
    D2S_SKILL_252,
    D2S_SKILL_253,
    D2S_SKILL_254,
    D2S_SKILL_255,
    D2S_SKILL_256,
    D2S_SKILL_257,
    D2S_SKILL_258,
    D2S_SKILL_259,
    D2S_SKILL_260,
    D2S_SKILL_261,
    D2S_SKILL_262,
    D2S_SKILL_263,
    D2S_SKILL_264,
    D2S_SKILL_265,
    D2S_SKILL_266,
    D2S_SKILL_267,
    D2S_SKILL_268,
    D2S_SKILL_269,
    D2S_SKILL_270,
    D2S_SKILL_271,
    D2S_SKILL_272,
    D2S_SKILL_273,
    D2S_SKILL_274,
    D2S_SKILL_275,
    D2S_SKILL_276,
    D2S_SKILL_277,
    D2S_SKILL_278,
    D2S_SKILL_279,
    D2S_SKILL_280,
    D2S_SKILL_281,
    D2S_SKILL_282,
    D2S_SKILL_283,
    D2S_SKILL_284,
    D2S_SKILL_285,
    D2S_SKILL_286,
    D2S_SKILL_287,
    D2S_SKILL_288,
    D2S_SKILL_289,
    D2S_SKILL_290,
    D2S_SKILL_291,
    D2S_SKILL_292,
    D2S_SKILL_293,
    D2S_SKILL_294,
    D2S_SKILL_295,
    D2S_SKILL_296,
    D2S_SKILL_297,
    D2S_SKILL_298,
    D2S_SKILL_299,
    D2S_SKILL_300,
    D2S_SKILL_301,
    D2S_SKILL_302,
    D2S_SKILL_303,
    D2S_SKILL_304,
    D2S_SKILL_305,
    D2S_SKILL_306,
    D2S_SKILL_307,
    D2S_SKILL_308,
    D2S_SKILL_309,
    D2S_SKILL_310,
    D2S_SKILL_311,
    D2S_SKILL_312,
    D2S_SKILL_313,
    D2S_SKILL_314,
    D2S_SKILL_315,
    D2S_SKILL_316,
    D2S_SKILL_317,
    D2S_SKILL_318,
    D2S_SKILL_319,
    D2S_SKILL_320,
    D2S_SKILL_321,
    D2S_SKILL_322,
    D2S_SKILL_323,
    D2S_SKILL_324,
    D2S_SKILL_325,
    D2S_SKILL_326,
    D2S_SKILL_327,
    D2S_SKILL_328,
    D2S_SKILL_329,
    D2S_SKILL_330,
    D2S_SKILL_331,
    D2S_SKILL_332,
    D2S_SKILL_333,
    D2S_SKILL_334,
    D2S_SKILL_335,
    D2S_SKILL_336,
    D2S_SKILL_337,
    D2S_SKILL_338,
    D2S_SKILL_339,
    D2S_SKILL_340,
    D2S_SKILL_341,
    D2S_SKILL_342,
    D2S_SKILL_343,
    D2S_SKILL_344,
    D2S_SKILL_345,
    D2S_SKILL_346,
    D2S_SKILL_347,
    D2S_SKILL_348,
    D2S_SKILL_349,
    D2S_SKILL_350,
    D2S_SKILL_351,
    D2S_SKILL_352,
    D2S_SKILL_353,
    D2S_SKILL_354,
    D2S_SKILL_355,
    D2S_SKILL_356
};

// Returns static string from library memory, no need to free
const char* getSkillName(D2S_SKILL skillID);
D2S_SKILL getSkillIDFromCharOffset(D2S_CHARCLASS class, unsigned int offset);
int getSkillLevel(D2CharHeader* c, D2S_SKILL skillID, void* charData, size_t dataLen);
int setSkillLevel(D2CharHeader* c, D2S_SKILL skillID, unsigned int level, void* charData, size_t dataLen);

#endif